## 墙推VScode!

`VScode`从15年刚开始推出，我就在使用了，做为第一个吃螃蟹的人，可以说见证了它一路的快速发展，直到现在它已经成为开源世界最火的IDE之一(弱弱的说一句，之一也许可以去掉)。

顺便歪楼说一句：我预言过三件事, 在13年预言`Golang`会火遍全世界,同时创建了14-19年最火的Golang隐修会社区，可惜因为某些原因被封停了，甚是遗憾；在15年预言`VScode`会成为世界上最好的IDE；同时我还是`jaeger tracing`项目的第一个star用户(是的，比作者还早)，当时就很看好这个项目的后续发展。

现在呢，我在这里正式预言： **未来`Rust`会成为主流编程语言之一，在几乎所有开发领域都将大放光彩**，总之牛逼已吹下，希望不要被打脸:(

下面继续简单介绍下VScode,以下内容引用于官网：

> Visual Studio Code(VS Code)是微软2015年推出的一个轻量但功能强大的源代码编辑器，基于 Electron 开发，支持 Windows、Linux 和 macOS 操作系统。它内置了对JavaScript，TypeScript和Node.js的支持并且具有丰富的其它语言和扩展的支持，功能超级强大。Visual Studio Code是一款免费开源的现代化轻量级代码编辑器，支持几乎所有主流的开发语言的语法高亮、智能代码补全、自定义快捷键、括号匹配和颜色区分、代码片段、代码对比 Diff、GIT命令 等特性，支持插件扩展，并针对网页开发和云端应用开发做了优化。

## 安装Vscode的Rust插件

在VScode的左侧扩展目录里，搜索`rust`,你能看到两个Rust插件，如果没有意外，这两个应该分别排名第一和第二:
1. 官方的`Rust`，作者是`The Rust Programming Language`, 官方出品，牛逼就完了，但是。。。我们并不推荐，这个插件有几个问题:
- 首先是在代码跳转上支持的很烂，只能在自己的代码库中跳转，一旦跳到别的三方库，那就无法继续跳转，对于查看标准库和三方库的源码带来了极大的困扰
- 其次，不支持类型自动标注，对于Rust语言而言，类型说明是非常重要的，特别是在你不知道给变量一个什么类型时，这种IDE的自动提示就变得弥足珍贵
- 代码提示不太好用，有些方法既不会提示，也不能跳转

2. 社区驱动的`rust-analyzer`，非常推荐，上面说的所有问题，在这个插件上都得到了解决，不得不说，rust社区 yyds!

所以，综上所述，我们选择`rust-analyer`作为Rust语言的插件，具体的安装很简单，点击插件，选择安装即可，根据提示可能需要重新加载IDE。

安装完成后，在第一次打开Rust项目时，需要安装一些依赖，具体的状态在左下角会进行提示，包括下载、代码构建building等。

当插件使用默认设置时，每一次保存代码，都会出进行一次重新编译，如果你的电脑慢，有一点一定要注意：在编译器构建代码的同时，不要在终端再运行`cargo run`等命令进行编译，不然会获得一个报错提示，大意是当前文件目录已经被锁定，等待其它使用者释放，如果等了很久ide还是没有释放(虽然我没遇到过，但是存在这个可能性)，你可以关掉ide，并手动kill掉`rust-anylyzer`，然后重新尝试。

> 在搜索VScode插件时，报错：`提取扩展出错，XHR failed`，这个报错是因为网络原因导致，很可能是你的网络不行或者翻墙工具阻拦你的访问，试着关掉翻墙，再进行尝试

## 安装其它好用的插件

在此，再推荐大家几个好用的插件：
1. `Better TOML`，用于更好的展示.toml文件
2. `Error Lens`, 更好的获得错误展示
3. `One Dark Pro`, 非常好看的Vscode主题
4. `CodeLLDB`, debugger程序

好了，至此，Vscode的配置就已经全部结束，是不是很简单？下面让我们来用Cargo创建一个Rust项目，然后用Vscode打开.